## com.puppycrawl.tools.checkstyle.checks.annotation
Class SuppressWarningsCheck

    java.lang.Object
      com.puppycrawl.tools.checkstyle.api.AutomaticBean
          com.puppycrawl.tools.checkstyle.api.AbstractViolationReporter
              com.puppycrawl.tools.checkstyle.api.Check
                  com.puppycrawl.tools.checkstyle.checks.AbstractFormatCheck
                      com.puppycrawl.tools.checkstyle.checks.annotation.SuppressWarningsCheck

All Implemented Interfaces:
  Configurable, Contextualizable

    public class SuppressWarningsCheck

extends AbstractFormatCheck

This check allows you to specify what warnings that `SuppressWarnings` is not allowed to suppress. You can also specify a list of TokenTypes that the configured warning(s) cannot be suppressed on.

The `warnings` property is a regex pattern. Any warning being suppressed matching this pattern will be flagged.

By default, any warning specified will be disallowed on all legal TokenTypes unless otherwise specified via the `tokens` property. Also, by default warnings that are empty strings or all whitespace (regex: ^$|^\s+$) are flagged. By specifying, the format property these defaults no longer apply.

Limitations: This check does not consider conditionals inside the SuppressWarnings annotation.
For example: `@SupressWarnings((false) ? (true) ? "unchecked" : "foo" : "unused")` According to the above example, the "unused" warning is being suppressed not the "unchecked" or "foo" warnings. All of these warnings will be considered and matched against regardless of what the conditional evaluates to.

This check can be configured so that the "unchecked" and "unused" warnings cannot be suppressed on anything but variable and parameter declarations. See below of an example.

     <module name="SuppressWarnings">
        <property name="format"
            value="^unchecked$|^unused$"/>
        <property name="tokens"
            value="
            CLASS_DEF,INTERFACE_DEF,ENUM_DEF,
            ANNOTATION_DEF,ANNOTATION_FIELD_DEF,
            ENUM_CONSTANT_DEF,METHOD_DEF,CTOR_DEF
            "/>
     </module>

Author:
  Travis Schneeberger

Constructor Summary
`SuppressWarningsCheck()` Ctor that specifies the default for the format property as specified in the class javadocs.

Method Summary
`int[]` `getAcceptableTokens()` The configurable token set.
`int[]` `getDefaultTokens()` Returns the default token a check is interested in.
`void` `visitToken(DetailAST aAST)` Called to process a token.

Methods inherited from class com.puppycrawl.tools.checkstyle.checks.AbstractFormatCheck
`getFormat, getRegexp, setCompileFlags, setFormat`

Methods inherited from class com.puppycrawl.tools.checkstyle.api.Check
`beginTree, destroy, finishTree, getClassLoader, getFileContents, getLines, getRequiredTokens, getTabWidth, getTokenNames, init, leaveToken, log, log, setClassLoader, setFileContents, setMessages, setTabWidth, setTokens`

Methods inherited from class com.puppycrawl.tools.checkstyle.api.AbstractViolationReporter
`getCustomMessages, getId, getMessageBundle, getSeverity, getSeverityLevel, log, setId, setSeverity`

Methods inherited from class com.puppycrawl.tools.checkstyle.api.AutomaticBean
`configure, contextualize, finishLocalSetup, getConfiguration, setupChild`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SuppressWarningsCheck

    public SuppressWarningsCheck()

  Ctor that specifies the default for the format property as specified in the class javadocs.

Method Detail

### getDefaultTokens

    public final int[] getDefaultTokens()

  Returns the default token a check is interested in. Only used if the configuration for a check does not define the tokens.

  Specified by:
    `getDefaultTokens` in class `Check`
  Returns:
    the default tokens
  See Also:
    `TokenTypes`

### getAcceptableTokens

    public final int[] getAcceptableTokens()

  The configurable token set. Used to protect Checks against malicious users who specify an unacceptable token set in the configuration file. The default implementation returns the check's default tokens.

  Overrides:
    `getAcceptableTokens` in class `Check`
  Returns:
    the token set this check is designed for.
  See Also:
    `TokenTypes`

### visitToken

    public void visitToken(DetailAST aAST)

  Called to process a token.

  Overrides:
    `visitToken` in class `Check`
  Parameters:
    `aAST` - the token to process

Copyright © 2001-2011. All Rights Reserved.